!!----
!!----
!!----
SubModule (CFML_Bonds_Tables) TAB_Set_BondsT
   Implicit none
  Contains

   !!----
   !!---- SET_BONDS_TABLE
   !!----    Fills the components of the Bond_Length_Table variable
   !!----
   !!---- 15/04/2019
   !!
   Module Subroutine Set_Bonds_Table()

      if (.not. allocated(Bond_Length_Table) ) allocate (Bond_Length_Table(3,103,103))
      Bond_Length_Table(:,:,:)=0.0_cp

      Bond_Length_Table(1,  1,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.059, 1.033, 0.967, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 1.723, 0.000,  &
                                         1.670, 1.728, 1.691, 1.698, 1.617,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.684, 0.000, 1.782, 1.847,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.769, 1.732, 1.684,  &
                                         1.659, 1.603, 1.610, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.069,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  3,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.949, 1.930, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.510, 2.461, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.823,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.079, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  4,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.611, 1.506, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  5,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 1.775,  &
                                         1.606, 1.549, 1.468, 1.366, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 1.922,  &
                                         1.802, 1.758, 0.000, 0.000, 0.000,  &
                                         2.528, 2.178, 2.322, 2.294, 2.255,  &
                                         2.140, 2.218, 2.086, 2.209, 2.219,  &
                                         0.000, 0.000, 2.041, 0.000, 1.967,  &
                                         0.000, 0.000, 0.000, 2.574, 2.335,  &
                                         0.000, 2.468, 0.000, 2.263, 2.367,  &
                                         2.224, 2.352, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.220, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.403, 2.292,  &
                                         2.283, 2.236, 2.246, 2.238, 2.286,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.569, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  6,1:103) =(/ 1.059, 0.000, 0.000, 0.000, 1.606,  &
                                         1.530, 1.488, 1.413, 1.340, 0.000,  &
                                         0.000, 0.000, 0.000, 1.863, 1.836,  &
                                         1.751, 1.713, 0.000, 0.000, 0.000,  &
                                         2.492, 2.215, 2.074, 1.702, 1.940,  &
                                         1.928, 1.896, 1.882, 1.861, 2.003,  &
                                         0.000, 0.000, 1.943, 1.893, 1.910,  &
                                         0.000, 0.000, 0.000, 2.649, 2.320,  &
                                         2.241, 2.059, 1.884, 2.049, 2.122,  &
                                         1.953, 2.093, 0.000, 0.000, 0.000,  &
                                         0.000, 2.116, 2.095, 0.000, 0.000,  &
                                         0.000, 0.000, 2.748, 2.654, 0.000,  &
                                         0.000, 2.809, 2.815, 2.738, 0.000,  &
                                         0.000, 0.000, 2.667, 0.000, 2.657,  &
                                         2.425, 2.190, 1.850, 1.815, 1.742,  &
                                         2.060, 2.041, 1.992, 2.003, 2.042,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.554,  &
                                         0.000, 2.509, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2,  6,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.380, 1.372, 1.350, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 1.651,  &
                                         1.660, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.799, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(3,  6,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.200, 1.136, 1.210, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  7,1:103) =(/ 1.033, 0.000, 0.000, 0.000, 1.549,  &
                                         1.488, 1.420, 1.438, 1.406, 0.000,  &
                                         0.000, 0.000, 0.000, 1.743, 1.652,  &
                                         1.642, 3.059, 0.000, 0.000, 0.000,  &
                                         0.000, 1.920, 2.097, 1.980, 1.919,  &
                                         2.029, 1.971, 2.082, 1.983, 1.988,  &
                                         1.966, 0.000, 1.858, 1.846, 1.843,  &
                                         0.000, 0.000, 0.000, 0.000, 2.060,  &
                                         2.043, 2.148, 2.049, 1.943, 0.000,  &
                                         2.023, 2.281, 2.245, 0.000, 0.000,  &
                                         0.000, 1.980, 2.042, 0.000, 0.000,  &
                                         0.000, 2.714, 2.615, 0.000, 2.471,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.433, 0.000, 0.000, 0.000, 2.469,  &
                                         0.000, 2.164, 1.796, 1.740, 2.024,  &
                                         1.706, 1.834, 2.025, 2.142, 2.016,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.496,  &
                                         0.000, 2.439, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2,  7,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.372, 1.240, 1.215, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 1.571,  &
                                         1.541, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.730, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.837, 1.790, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 1.742, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(3,  7,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.136, 1.124, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  8,1:103) =(/ 0.967, 0.000, 1.949, 1.611, 1.468,  &
                                         1.413, 1.438, 1.482, 2.691, 0.000,  &
                                         2.336, 2.016, 1.618, 1.645, 1.662,  &
                                         1.577, 1.414, 0.000, 2.764, 2.330,  &
                                         2.051, 2.004, 1.658, 1.690, 1.915,  &
                                         1.929, 2.021, 2.003, 1.935, 1.981,  &
                                         1.803, 1.721, 1.710, 1.608, 1.581,  &
                                         0.000, 2.887, 2.487, 2.287, 2.034,  &
                                         1.866, 1.921, 1.710, 2.056, 1.959,  &
                                         2.010, 0.000, 2.219, 2.082, 2.028,  &
                                         1.977, 1.927, 2.144, 1.725, 3.052,  &
                                         2.738, 2.441, 2.370, 2.391, 2.354,  &
                                         0.000, 2.288, 2.314, 2.282, 2.294,  &
                                         2.269, 2.276, 2.246, 2.233, 2.218,  &
                                         2.204, 2.028, 1.920, 1.850, 1.751,  &
                                         1.740, 1.950, 2.016, 1.983, 2.093,  &
                                         2.142, 2.332, 2.270, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.377,  &
                                         2.337, 1.813, 1.730, 2.350, 2.365,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2,  8,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.350, 1.215, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 1.513,  &
                                         1.436, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.660, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(3,  8,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.210, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1,  9,1:103) =(/ 0.000, 0.000, 1.930, 1.506, 1.366,  &
                                         1.340, 1.406, 2.691, 2.568, 0.000,  &
                                         2.308, 1.988, 1.806, 1.636, 1.579,  &
                                         1.527, 0.000, 0.000, 2.693, 2.309,  &
                                         2.068, 1.918, 1.833, 1.926, 1.809,  &
                                         1.900, 2.009, 1.860, 1.956, 1.972,  &
                                         1.912, 1.767, 1.678, 0.000, 1.780,  &
                                         0.000, 2.942, 2.465, 2.267, 2.031,  &
                                         1.950, 1.901, 0.000, 1.963, 0.000,  &
                                         2.068, 2.055, 2.221, 2.040, 2.056,  &
                                         1.934, 1.937, 1.854, 0.000, 3.113,  &
                                         2.666, 2.409, 2.165, 0.000, 2.428,  &
                                         0.000, 2.320, 0.000, 2.266, 2.290,  &
                                         0.000, 2.224, 2.160, 0.000, 2.172,  &
                                         2.102, 2.090, 1.906, 1.835, 1.876,  &
                                         1.828, 2.272, 1.890, 1.961, 2.427,  &
                                         2.826, 2.475, 2.357, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.333,  &
                                         2.165, 2.118, 2.158, 2.415, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 11,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.336, 2.308, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.952, 2.827, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.038,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.421, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 12,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.016, 1.988, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.494, 2.509, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 13,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.618, 1.806, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.257, 2.111, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.265,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.483, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 14,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.863, 1.743, 1.645, 1.636, 0.000,  &
                                         0.000, 0.000, 0.000, 2.359, 2.264,  &
                                         2.145, 2.020, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.254,  &
                                         2.329, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.351, 0.000, 2.284,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.603, 0.000, 2.423, 2.379,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.586, 2.543,  &
                                         2.400, 2.398, 2.233, 0.000, 2.533,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 15,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 1.922,  &
                                         1.836, 1.652, 1.662, 1.579, 0.000,  &
                                         0.000, 0.000, 0.000, 2.264, 2.214,  &
                                         2.018, 1.932, 0.000, 0.000, 0.000,  &
                                         0.000, 2.585, 2.357, 2.288, 2.289,  &
                                         2.204, 2.233, 2.189, 2.357, 0.000,  &
                                         0.000, 0.000, 2.350, 2.093, 2.366,  &
                                         0.000, 0.000, 0.000, 0.000, 2.692,  &
                                         2.697, 2.274, 2.494, 2.300, 2.425,  &
                                         2.452, 2.419, 2.524, 0.000, 0.000,  &
                                         0.000, 2.327, 2.445, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.500, 2.589, 2.485, 2.478,  &
                                         2.379, 2.355, 2.282, 2.278, 2.490,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 15,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.651, 1.571, 1.513, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.038,  &
                                         1.913, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.124, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 16,1:103) =(/ 0.000, 0.000, 2.510, 0.000, 1.802,  &
                                         1.751, 1.642, 1.577, 1.527, 0.000,  &
                                         2.952, 2.494, 2.257, 2.145, 2.018,  &
                                         2.031, 2.072, 0.000, 3.250, 2.838,  &
                                         2.549, 2.425, 2.183, 2.401, 2.461,  &
                                         2.304, 2.450, 2.294, 2.260, 2.328,  &
                                         2.233, 2.159, 2.275, 2.193, 2.206,  &
                                         0.000, 3.382, 3.008, 2.750, 2.572,  &
                                         2.428, 2.364, 2.302, 2.363, 2.235,  &
                                         2.327, 2.527, 2.544, 2.470, 2.631,  &
                                         2.334, 2.405, 2.629, 0.000, 3.588,  &
                                         3.173, 2.928, 2.905, 2.884, 2.868,  &
                                         0.000, 2.769, 2.925, 2.890, 0.000,  &
                                         2.741, 2.638, 2.617, 2.870, 2.713,  &
                                         2.674, 2.594, 2.426, 2.503, 2.334,  &
                                         2.377, 2.462, 2.247, 2.341, 2.445,  &
                                         3.054, 2.744, 2.631, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.839,  &
                                         0.000, 2.778, 2.770, 2.933, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 16,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.660, 1.541, 1.436, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 1.913,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.080, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 17,1:103) =(/ 0.000, 0.000, 2.461, 2.000, 1.758,  &
                                         1.713, 3.059, 1.414, 0.000, 0.000,  &
                                         2.827, 2.509, 2.111, 2.020, 1.932,  &
                                         2.072, 2.306, 0.000, 3.188, 2.862,  &
                                         2.557, 2.350, 2.300, 2.416, 2.445,  &
                                         2.350, 2.356, 2.383, 2.455, 2.275,  &
                                         2.128, 2.273, 2.116, 2.178, 2.402,  &
                                         0.000, 3.364, 3.024, 2.740, 2.450,  &
                                         2.328, 2.401, 2.481, 2.340, 2.323,  &
                                         2.103, 2.619, 2.580, 2.487, 2.387,  &
                                         2.331, 2.419, 2.513, 0.000, 3.569,  &
                                         3.163, 2.931, 2.605, 2.862, 2.945,  &
                                         0.000, 0.000, 2.854, 2.744, 2.710,  &
                                         0.000, 0.000, 2.613, 0.000, 2.772,  &
                                         0.000, 2.365, 2.275, 2.192, 2.316,  &
                                         2.393, 2.354, 2.315, 2.411, 2.505,  &
                                         2.482, 2.490, 2.928, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.919,  &
                                         0.000, 2.646, 0.000, 2.810, 2.815,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 19,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.764, 2.693, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.250, 3.188, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.318,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.636, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 20,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.330, 2.309, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.838, 2.862, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.006,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.245, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 21,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.528,  &
                                         2.492, 0.000, 2.051, 2.068, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.549, 2.557, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 22,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.178,  &
                                         2.215, 1.920, 2.004, 1.918, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.585,  &
                                         2.425, 2.350, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.677, 0.000, 2.700,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 23,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.322,  &
                                         2.074, 2.097, 1.658, 1.833, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.357,  &
                                         2.183, 2.300, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.536, 0.000, 2.550,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.653, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 23,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.730, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 24,1:103) =(/ 1.723, 0.000, 0.000, 0.000, 2.294,  &
                                         1.702, 1.980, 1.690, 1.926, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.288,  &
                                         2.401, 2.416, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.460, 2.453, 2.441,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.801, 2.669, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 25,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.255,  &
                                         1.940, 1.919, 1.915, 1.809, 0.000,  &
                                         0.000, 0.000, 0.000, 2.254, 2.289,  &
                                         2.461, 2.445, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.400, 2.358, 2.588,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.486, 2.719, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 26,1:103) =(/ 1.670, 0.000, 0.000, 0.000, 2.140,  &
                                         1.928, 2.029, 1.929, 1.900, 0.000,  &
                                         0.000, 0.000, 0.000, 2.329, 2.204,  &
                                         2.304, 2.350, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.352, 2.393, 2.470,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.560, 2.593, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 27,1:103) =(/ 1.728, 0.000, 0.000, 0.000, 2.218,  &
                                         1.896, 1.971, 2.021, 2.009, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.233,  &
                                         2.450, 2.356, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.323, 0.000, 2.416,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.640, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 28,1:103) =(/ 1.691, 0.000, 0.000, 0.000, 2.086,  &
                                         1.882, 2.082, 2.003, 1.860, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.189,  &
                                         2.294, 2.383, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.333, 2.351, 2.410,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.673, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 29,1:103) =(/ 1.698, 0.000, 0.000, 0.000, 2.209,  &
                                         1.861, 1.983, 1.935, 1.956, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.357,  &
                                         2.260, 2.455, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.367, 3.109, 2.412,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.594, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 30,1:103) =(/ 1.617, 0.000, 0.000, 0.000, 2.219,  &
                                         2.003, 1.988, 1.981, 1.972, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.328, 2.275, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.390,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.574, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 31,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.966, 1.803, 1.912, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.233, 2.128, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.300,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.530, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 32,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.721, 1.767, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.159, 2.273, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.543, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 33,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.041,  &
                                         1.943, 1.858, 1.710, 1.678, 0.000,  &
                                         0.000, 0.000, 0.000, 2.351, 2.350,  &
                                         2.275, 2.116, 0.000, 0.000, 0.000,  &
                                         0.000, 2.677, 2.536, 2.460, 2.400,  &
                                         2.352, 2.323, 2.333, 2.367, 0.000,  &
                                         0.000, 0.000, 2.459, 2.355, 2.320,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.741, 2.582, 2.512, 2.446, 2.416,  &
                                         2.386, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.571, 2.590, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.549, 2.575,  &
                                         2.481, 0.000, 2.366, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 33,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.837, 1.660, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.124,  &
                                         2.080, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 34,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.893, 1.846, 1.608, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.093,  &
                                         2.193, 2.178, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.453, 2.358,  &
                                         2.393, 0.000, 2.351, 3.109, 0.000,  &
                                         0.000, 0.000, 2.355, 2.340, 2.508,  &
                                         0.000, 0.000, 0.000, 0.000, 2.639,  &
                                         0.000, 2.491, 0.000, 0.000, 2.457,  &
                                         0.000, 2.581, 0.000, 0.000, 0.000,  &
                                         0.000, 2.524, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.635, 2.572,  &
                                         2.541, 2.529, 2.400, 0.000, 2.624,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 34,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.790, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 35,1:103) =(/ 0.000, 0.000, 2.823, 0.000, 1.967,  &
                                         1.910, 1.843, 1.581, 1.780, 0.000,  &
                                         3.038, 0.000, 2.265, 2.284, 2.366,  &
                                         2.206, 2.402, 0.000, 3.318, 3.006,  &
                                         0.000, 2.700, 2.550, 2.441, 2.588,  &
                                         2.470, 2.416, 2.410, 2.412, 2.390,  &
                                         2.300, 0.000, 2.320, 2.508, 2.542,  &
                                         0.000, 3.492, 3.054, 0.000, 2.665,  &
                                         2.533, 2.616, 2.440, 2.521, 2.530,  &
                                         2.458, 2.450, 2.611, 2.626, 2.510,  &
                                         2.540, 2.692, 2.646, 0.000, 3.722,  &
                                         3.319, 3.103, 0.000, 0.000, 3.070,  &
                                         0.000, 0.000, 0.000, 2.905, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.604, 2.619, 2.573,  &
                                         2.550, 2.580, 2.460, 2.413, 2.539,  &
                                         2.533, 2.960, 3.077, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.886,  &
                                         0.000, 2.797, 0.000, 3.090, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 37,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.887, 2.942, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.382, 3.364, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.492,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.720, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 38,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.487, 2.465, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.008, 3.024, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.054,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.057, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 39,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.574,  &
                                         2.649, 0.000, 2.287, 2.267, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.750, 2.740, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 40,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.335,  &
                                         2.320, 2.060, 2.034, 2.031, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.692,  &
                                         2.572, 2.450, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.639, 2.665,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.850, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 41,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.241, 2.043, 1.866, 1.950, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.697,  &
                                         2.428, 2.328, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.741, 0.000, 2.533,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.745, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 42,1:103) =(/ 1.684, 0.000, 0.000, 0.000, 2.468,  &
                                         2.059, 2.148, 1.921, 1.901, 0.000,  &
                                         0.000, 0.000, 0.000, 2.603, 2.274,  &
                                         2.364, 2.401, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.582, 2.491, 2.616,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.791, 2.867, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 42,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.799, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 43,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         1.884, 2.049, 1.710, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.494,  &
                                         2.302, 2.481, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.512, 0.000, 2.440,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 44,1:103) =(/ 1.782, 0.000, 0.000, 0.000, 2.263,  &
                                         2.049, 1.943, 2.056, 1.963, 0.000,  &
                                         0.000, 0.000, 0.000, 2.423, 2.300,  &
                                         2.363, 2.340, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.446, 0.000, 2.521,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.744, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(2, 44,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 1.742, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 45,1:103) =(/ 1.847, 0.000, 0.000, 0.000, 2.367,  &
                                         2.122, 0.000, 1.959, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.379, 2.425,  &
                                         2.235, 2.323, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.416, 2.457, 2.530,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.715, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 46,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.224,  &
                                         1.953, 2.023, 2.010, 2.068, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.452,  &
                                         2.327, 2.103, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.386, 0.000, 2.458,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.624, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 47,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.352,  &
                                         2.093, 2.281, 0.000, 2.055, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.419,  &
                                         2.527, 2.619, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.581, 2.450,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.828, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 48,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.245, 2.219, 2.221, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.524,  &
                                         2.544, 2.580, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.611,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.750, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 49,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.082, 2.040, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.470, 2.487, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.626,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.759, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 50,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.028, 2.056, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.631, 2.387, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.510,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.634, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 51,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.977, 1.934, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.334, 2.331, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.540,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.072, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 52,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.116, 1.980, 1.927, 1.937, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.327,  &
                                         2.405, 2.419, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.801, 2.486,  &
                                         2.560, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.571, 2.524, 2.692,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.791, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.704, 2.926, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.575, 0.000, 2.732,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 53,1:103) =(/ 0.000, 0.000, 3.079, 0.000, 2.220,  &
                                         2.095, 2.042, 2.144, 1.854, 0.000,  &
                                         3.421, 0.000, 2.483, 0.000, 2.445,  &
                                         2.629, 2.513, 0.000, 3.636, 3.245,  &
                                         0.000, 0.000, 2.653, 2.669, 2.719,  &
                                         2.593, 2.640, 2.673, 2.594, 2.574,  &
                                         2.530, 2.543, 2.590, 0.000, 2.646,  &
                                         0.000, 3.720, 3.057, 0.000, 2.850,  &
                                         2.745, 2.867, 0.000, 2.744, 2.715,  &
                                         2.624, 2.828, 2.750, 2.759, 2.634,  &
                                         3.072, 2.926, 2.917, 0.000, 3.934,  &
                                         3.482, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.305, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.027,  &
                                         0.000, 0.000, 0.000, 2.840, 2.718,  &
                                         2.774, 2.729, 2.658, 2.650, 2.702,  &
                                         3.476, 3.227, 3.226, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 3.205, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 54,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.725, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 55,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.052, 3.113, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.588, 3.569, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.722,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.934, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 56,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.738, 2.666, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.173, 3.163, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.319,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.482, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 57,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.714, 2.441, 2.409, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.928, 2.931, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.103,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 58,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.748, 2.615, 2.370, 2.165, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.905, 2.605, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 59,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.654, 0.000, 2.391, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.884, 2.862, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 60,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.471, 2.354, 2.428, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.868, 2.945, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.070,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 62,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.809, 0.000, 2.288, 2.320, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.769, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 63,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.815, 0.000, 2.314, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.925, 2.854, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.305, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 64,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.738, 0.000, 2.282, 2.266, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.890, 2.744, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.905,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 65,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.294, 2.290, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.710, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 66,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.433, 2.269, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.741, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 67,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.276, 2.224, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.638, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 68,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.667, 0.000, 2.246, 2.160, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.617, 2.613, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 69,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.233, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.870, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 70,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.657, 2.469, 2.218, 2.172, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.713, 2.772, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.027, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 71,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.425, 0.000, 2.204, 2.102, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.674, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 72,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.190, 2.164, 2.028, 2.090, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.500,  &
                                         2.594, 2.365, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 73,1:103) =(/ 1.769, 0.000, 0.000, 0.000, 0.000,  &
                                         1.850, 1.796, 1.920, 1.906, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.589,  &
                                         2.426, 2.275, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.604,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 74,1:103) =(/ 1.732, 0.000, 0.000, 0.000, 2.403,  &
                                         1.815, 1.740, 1.850, 1.835, 0.000,  &
                                         0.000, 0.000, 0.000, 2.586, 2.485,  &
                                         2.503, 2.192, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.549, 2.635, 2.619,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.840, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 75,1:103) =(/ 1.684, 0.000, 0.000, 0.000, 2.292,  &
                                         1.742, 2.024, 1.751, 1.876, 0.000,  &
                                         0.000, 0.000, 0.000, 2.543, 2.478,  &
                                         2.334, 2.316, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.575, 2.572, 2.573,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.718, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 76,1:103) =(/ 1.659, 0.000, 0.000, 0.000, 2.283,  &
                                         2.060, 1.706, 1.740, 1.828, 0.000,  &
                                         0.000, 0.000, 0.000, 2.400, 2.379,  &
                                         2.377, 2.393, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.481, 2.541, 2.550,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.774, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 77,1:103) =(/ 1.603, 0.000, 0.000, 0.000, 2.236,  &
                                         2.041, 1.834, 1.950, 2.272, 0.000,  &
                                         0.000, 0.000, 0.000, 2.398, 2.355,  &
                                         2.462, 2.354, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.529, 2.580,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.729, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 78,1:103) =(/ 1.610, 0.000, 0.000, 0.000, 2.246,  &
                                         1.992, 2.025, 2.016, 1.890, 0.000,  &
                                         0.000, 0.000, 0.000, 2.233, 2.282,  &
                                         2.247, 2.315, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.366, 2.400, 2.460,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.575, 2.658, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 79,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.238,  &
                                         2.003, 2.142, 1.983, 1.961, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.278,  &
                                         2.341, 2.411, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.413,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.650, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 80,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.286,  &
                                         2.042, 2.016, 2.093, 2.427, 0.000,  &
                                         0.000, 0.000, 0.000, 2.533, 2.490,  &
                                         2.445, 2.505, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 2.624, 2.539,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.732, 2.702, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 81,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.142, 2.826, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         3.054, 2.482, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.533,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.476, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 82,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.332, 2.475, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.744, 2.490, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.960,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.227, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 83,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.270, 2.357, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.631, 2.928, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.077,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.226, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 90,1:103) =(/ 2.069, 0.000, 0.000, 0.000, 0.000,  &
                                         2.554, 2.496, 2.377, 2.333, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.839, 2.919, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.886,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 91,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.337, 2.165, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 92,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 2.569,  &
                                         2.509, 2.439, 1.813, 2.118, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.778, 2.646, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 2.797,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 3.205, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 93,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 1.730, 2.158, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.770, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 94,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.350, 2.415, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         2.933, 2.810, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 3.090,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Bond_Length_Table(1, 95,1:103) =(/ 0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 2.365, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 2.815, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000, 0.000, 0.000,  &
                                         0.000, 0.000, 0.000 /)

      Set_BT_Variable =.true.

   End Subroutine Set_Bonds_Table

End SubModule TAB_Set_BondsT